/* spek-window.c generated by valac, the Vala compiler
 * generated from spek-window.vala, do not modify */

/* spek-window.vala
 *
 * Copyright (C) 2010  Alexander Kojevnikov <alexander@kojevnikov.com>
 *
 * Spek is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Spek is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Spek.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <config.h>
#include <spek-platform.h>
#include <gio/gio.h>
#include <stdio.h>


#define SPEK_TYPE_WINDOW (spek_window_get_type ())
#define SPEK_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPEK_TYPE_WINDOW, SpekWindow))
#define SPEK_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPEK_TYPE_WINDOW, SpekWindowClass))
#define SPEK_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPEK_TYPE_WINDOW))
#define SPEK_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPEK_TYPE_WINDOW))
#define SPEK_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPEK_TYPE_WINDOW, SpekWindowClass))

typedef struct _SpekWindow SpekWindow;
typedef struct _SpekWindowClass SpekWindowClass;
typedef struct _SpekWindowPrivate SpekWindowPrivate;

#define SPEK_TYPE_MESSAGE_BAR (spek_message_bar_get_type ())
#define SPEK_MESSAGE_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPEK_TYPE_MESSAGE_BAR, SpekMessageBar))
#define SPEK_MESSAGE_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPEK_TYPE_MESSAGE_BAR, SpekMessageBarClass))
#define SPEK_IS_MESSAGE_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPEK_TYPE_MESSAGE_BAR))
#define SPEK_IS_MESSAGE_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPEK_TYPE_MESSAGE_BAR))
#define SPEK_MESSAGE_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPEK_TYPE_MESSAGE_BAR, SpekMessageBarClass))

typedef struct _SpekMessageBar SpekMessageBar;
typedef struct _SpekMessageBarClass SpekMessageBarClass;

#define SPEK_TYPE_SPECTROGRAM (spek_spectrogram_get_type ())
#define SPEK_SPECTROGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPEK_TYPE_SPECTROGRAM, SpekSpectrogram))
#define SPEK_SPECTROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SPEK_TYPE_SPECTROGRAM, SpekSpectrogramClass))
#define SPEK_IS_SPECTROGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPEK_TYPE_SPECTROGRAM))
#define SPEK_IS_SPECTROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPEK_TYPE_SPECTROGRAM))
#define SPEK_SPECTROGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SPEK_TYPE_SPECTROGRAM, SpekSpectrogramClass))

typedef struct _SpekSpectrogram SpekSpectrogram;
typedef struct _SpekSpectrogramClass SpekSpectrogramClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

struct _SpekWindow {
	GtkWindow parent_instance;
	SpekWindowPrivate * priv;
};

struct _SpekWindowClass {
	GtkWindowClass parent_class;
};

struct _SpekWindowPrivate {
	SpekMessageBar* message_bar;
	SpekSpectrogram* spectrogram;
	char* cur_dir;
	GtkFileFilter* filter_all;
	GtkFileFilter* filter_audio;
	GtkFileFilter* filter_png;
	char** audio_extensions;
	gint audio_extensions_length1;
	gint _audio_extensions_size_;
};

struct _Block3Data {
	int _ref_count_;
	SpekWindow * self;
	GtkAboutDialog* dlg;
};


static gpointer spek_window_parent_class = NULL;

GType spek_window_get_type (void);
GType spek_message_bar_get_type (void);
GType spek_spectrogram_get_type (void);
#define SPEK_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SPEK_TYPE_WINDOW, SpekWindowPrivate))
enum  {
	SPEK_WINDOW_DUMMY_PROPERTY
};
#define SPEK_WINDOW_full_title _ ("Spek - Acoustic Spectrum Analyser")
static void _gtk_main_quit_gtk_object_destroy (GtkObject* _sender, gpointer self);
static void spek_window_on_open_clicked (SpekWindow* self);
static void _spek_window_on_open_clicked_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void spek_window_on_save_clicked (SpekWindow* self);
static void _spek_window_on_save_clicked_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void _lambda8_ (GtkToolButton* s, SpekWindow* self);
static void __lambda8__gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void spek_window_on_about_clicked (SpekWindow* self);
static void _spek_window_on_about_clicked_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
SpekMessageBar* spek_message_bar_new (const char* message);
SpekMessageBar* spek_message_bar_construct (GType object_type, const char* message);
SpekSpectrogram* spek_spectrogram_new (void);
SpekSpectrogram* spek_spectrogram_construct (GType object_type);
static void spek_window_on_dropped (SpekWindow* self, GdkDragContext* cx, gint x, gint y, GtkSelectionData* data, guint info, guint time);
static void _spek_window_on_dropped_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self);
static void spek_window_open_file (SpekWindow* self, const char* file_name);
static void* spek_window_check_version (SpekWindow* self);
static void* _spek_window_check_version_gthread_func (gpointer self);
SpekWindow* spek_window_new (const char* file_name);
SpekWindow* spek_window_construct (GType object_type, const char* file_name);
void spek_spectrogram_open (SpekSpectrogram* self, const char* file_name);
const char* spek_spectrogram_get_file_name (SpekSpectrogram* self);
void spek_spectrogram_save (SpekSpectrogram* self, const char* file_name);
static void _lambda9_ (gint id, Block3Data* _data3_);
static void __lambda9__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
static void spek_window_url_hook (SpekWindow* self, GtkAboutDialog* about, const char* link);
static void _spek_window_url_hook_gtk_about_dialog_activate_link_func (GtkAboutDialog* about, const char* link_, gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
static gboolean _lambda10_ (SpekWindow* self);
static gboolean __lambda10__gsource_func (gpointer self);
static void spek_window_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GtkTargetEntry SPEK_WINDOW_DEST_TARGET_ENTRIES[1] = {{"text/uri-list", (guint) 0, (guint) 0}};


static void _gtk_main_quit_gtk_object_destroy (GtkObject* _sender, gpointer self) {
	gtk_main_quit ();
}


static void _spek_window_on_open_clicked_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	spek_window_on_open_clicked (self);
}


static void _spek_window_on_save_clicked_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	spek_window_on_save_clicked (self);
}


static void _lambda8_ (GtkToolButton* s, SpekWindow* self) {
	g_return_if_fail (s != NULL);
	gtk_object_destroy ((GtkObject*) self);
}


static void __lambda8__gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	_lambda8_ (_sender, self);
}


static void _spek_window_on_about_clicked_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	spek_window_on_about_clicked (self);
}


static void _spek_window_on_dropped_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self) {
	spek_window_on_dropped (self, context, x, y, selection_data, info, time_);
}


static void* _spek_window_check_version_gthread_func (gpointer self) {
	return spek_window_check_version (self);
}


SpekWindow* spek_window_construct (GType object_type, const char* file_name) {
	GError * _inner_error_;
	SpekWindow * self;
	GtkAccelGroup* group;
	GtkToolbar* toolbar;
	GtkToolButton* open;
	GtkToolButton* save;
	GtkSeparatorToolItem* _tmp0_;
	GtkToolButton* quit;
	GtkSeparatorToolItem* sep;
	GtkToolButton* about;
	SpekMessageBar* _tmp1_;
	SpekSpectrogram* _tmp2_;
	char* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GtkVBox* vbox;
	_inner_error_ = NULL;
	self = g_object_newv (object_type, 0, NULL);
	gtk_window_set_title ((GtkWindow*) self, SPEK_WINDOW_full_title);
	gtk_window_set_default_icon_name ("spek");
	gtk_window_set_default_size ((GtkWindow*) self, 640, 480);
	g_signal_connect ((GtkObject*) self, "destroy", (GCallback) _gtk_main_quit_gtk_object_destroy, NULL);
	group = gtk_accel_group_new ();
	gtk_window_add_accel_group ((GtkWindow*) self, group);
	toolbar = g_object_ref_sink ((GtkToolbar*) gtk_toolbar_new ());
	gtk_toolbar_set_style (toolbar, GTK_TOOLBAR_BOTH_HORIZ);
	open = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_OPEN));
	gtk_tool_item_set_is_important ((GtkToolItem*) open, TRUE);
	gtk_widget_add_accelerator ((GtkWidget*) open, "clicked", group, (guint) 'O', GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
	g_signal_connect_object (open, "clicked", (GCallback) _spek_window_on_open_clicked_gtk_tool_button_clicked, self, 0);
	gtk_toolbar_insert (toolbar, (GtkToolItem*) open, -1);
	save = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_SAVE));
	gtk_tool_item_set_is_important ((GtkToolItem*) save, TRUE);
	gtk_widget_add_accelerator ((GtkWidget*) save, "clicked", group, (guint) 'S', GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
	g_signal_connect_object (save, "clicked", (GCallback) _spek_window_on_save_clicked_gtk_tool_button_clicked, self, 0);
	gtk_toolbar_insert (toolbar, (GtkToolItem*) save, -1);
	gtk_toolbar_insert (toolbar, (GtkToolItem*) (_tmp0_ = g_object_ref_sink ((GtkSeparatorToolItem*) gtk_separator_tool_item_new ())), -1);
	_g_object_unref0 (_tmp0_);
	quit = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_QUIT));
	gtk_tool_item_set_is_important ((GtkToolItem*) quit, TRUE);
	gtk_widget_add_accelerator ((GtkWidget*) quit, "clicked", group, (guint) 'Q', GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
	g_signal_connect_object (quit, "clicked", (GCallback) __lambda8__gtk_tool_button_clicked, self, 0);
	gtk_toolbar_insert (toolbar, (GtkToolItem*) quit, -1);
	sep = g_object_ref_sink ((GtkSeparatorToolItem*) gtk_separator_tool_item_new ());
	gtk_tool_item_set_expand ((GtkToolItem*) sep, TRUE);
	gtk_separator_tool_item_set_draw (sep, FALSE);
	gtk_toolbar_insert (toolbar, (GtkToolItem*) sep, -1);
	about = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock (GTK_STOCK_ABOUT));
	gtk_tool_item_set_is_important ((GtkToolItem*) about, TRUE);
	gtk_widget_add_accelerator ((GtkWidget*) about, "clicked", group, gdk_keyval_from_name ("F1"), 0, GTK_ACCEL_VISIBLE);
	g_signal_connect_object (about, "clicked", (GCallback) _spek_window_on_about_clicked_gtk_tool_button_clicked, self, 0);
	gtk_toolbar_insert (toolbar, (GtkToolItem*) about, -1);
	self->priv->message_bar = (_tmp1_ = g_object_ref_sink (spek_message_bar_new (_ ("A new version of Spek is available on <a href=\"http://www.spek-projec" \
"t.org\">www.spek-project.org</a>"))), _g_object_unref0 (self->priv->message_bar), _tmp1_);
	self->priv->spectrogram = (_tmp2_ = g_object_ref_sink (spek_spectrogram_new ()), _g_object_unref0 (self->priv->spectrogram), _tmp2_);
	self->priv->cur_dir = (_tmp3_ = g_strdup (g_get_home_dir ()), _g_free0 (self->priv->cur_dir), _tmp3_);
	self->priv->filter_all = (_tmp4_ = g_object_ref_sink (gtk_file_filter_new ()), _g_object_unref0 (self->priv->filter_all), _tmp4_);
	gtk_file_filter_set_name (self->priv->filter_all, _ ("All files"));
	gtk_file_filter_add_pattern (self->priv->filter_all, "*");
	self->priv->filter_png = (_tmp5_ = g_object_ref_sink (gtk_file_filter_new ()), _g_object_unref0 (self->priv->filter_png), _tmp5_);
	gtk_file_filter_set_name (self->priv->filter_png, _ ("PNG images"));
	gtk_file_filter_add_pattern (self->priv->filter_png, "*.png");
	self->priv->filter_audio = (_tmp6_ = g_object_ref_sink (gtk_file_filter_new ()), _g_object_unref0 (self->priv->filter_audio), _tmp6_);
	gtk_file_filter_set_name (self->priv->filter_audio, _ ("Audio files"));
	{
		char** ext_collection;
		int ext_collection_length1;
		int ext_it;
		ext_collection = self->priv->audio_extensions;
		ext_collection_length1 = self->priv->audio_extensions_length1;
		for (ext_it = 0; ext_it < self->priv->audio_extensions_length1; ext_it = ext_it + 1) {
			char* ext;
			ext = g_strdup (ext_collection[ext_it]);
			{
				gtk_file_filter_add_pattern (self->priv->filter_audio, ext);
				_g_free0 (ext);
			}
		}
	}
	vbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) toolbar, FALSE, TRUE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->message_bar, FALSE, TRUE, (guint) 0);
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) self->priv->spectrogram, TRUE, TRUE, (guint) 0);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) vbox);
	gtk_widget_show_all ((GtkWidget*) toolbar);
	gtk_widget_show_all ((GtkWidget*) self->priv->spectrogram);
	gtk_widget_show ((GtkWidget*) vbox);
	gtk_widget_show ((GtkWidget*) self);
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, SPEK_WINDOW_DEST_TARGET_ENTRIES, G_N_ELEMENTS (SPEK_WINDOW_DEST_TARGET_ENTRIES), GDK_ACTION_COPY);
	g_signal_connect_object ((GtkWidget*) self, "drag-data-received", (GCallback) _spek_window_on_dropped_gtk_widget_drag_data_received, self, 0);
	if (file_name != NULL) {
		spek_window_open_file (self, file_name);
	}
	{
		g_thread_create (_spek_window_check_version_gthread_func, self, FALSE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch6_g_thread_error;
			}
			_g_object_unref0 (group);
			_g_object_unref0 (toolbar);
			_g_object_unref0 (open);
			_g_object_unref0 (save);
			_g_object_unref0 (quit);
			_g_object_unref0 (sep);
			_g_object_unref0 (about);
			_g_object_unref0 (vbox);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally6;
	__catch6_g_thread_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (group);
		_g_object_unref0 (toolbar);
		_g_object_unref0 (open);
		_g_object_unref0 (save);
		_g_object_unref0 (quit);
		_g_object_unref0 (sep);
		_g_object_unref0 (about);
		_g_object_unref0 (vbox);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_object_unref0 (group);
	_g_object_unref0 (toolbar);
	_g_object_unref0 (open);
	_g_object_unref0 (save);
	_g_object_unref0 (quit);
	_g_object_unref0 (sep);
	_g_object_unref0 (about);
	_g_object_unref0 (vbox);
	return self;
}


SpekWindow* spek_window_new (const char* file_name) {
	return spek_window_construct (SPEK_TYPE_WINDOW, file_name);
}


static void spek_window_on_dropped (SpekWindow* self, GdkDragContext* cx, gint x, gint y, GtkSelectionData* data, guint info, guint time) {
	GError * _inner_error_;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cx != NULL);
	g_return_if_fail (data != NULL);
	_inner_error_ = NULL;
	if (data->length > 0) {
		_tmp0_ = data->format == 8;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		char** _tmp2_;
		gint _files_size_;
		gint files_length1;
		char** _tmp1_;
		char** files;
		files = (_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data), files_length1 = _vala_array_length (_tmp1_), _files_size_ = files_length1, _tmp2_);
		if (files_length1 > 0) {
			{
				char* _tmp3_;
				char* _tmp4_;
				_tmp3_ = g_filename_from_uri (files[0], NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_CONVERT_ERROR) {
						goto __catch7_g_convert_error;
					}
					files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				spek_window_open_file (self, _tmp4_ = _tmp3_);
				_g_free0 (_tmp4_);
				gtk_drag_finish (cx, TRUE, FALSE, (guint32) time);
				files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
				return;
			}
			goto __finally7;
			__catch7_g_convert_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					_g_error_free0 (e);
				}
			}
			__finally7:
			if (_inner_error_ != NULL) {
				files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
	}
	gtk_drag_finish (cx, FALSE, FALSE, (guint32) time);
}


static void spek_window_open_file (SpekWindow* self, const char* file_name) {
	char* _tmp0_;
	char* _tmp2_;
	char* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_name != NULL);
	self->priv->cur_dir = (_tmp0_ = g_path_get_dirname (file_name), _g_free0 (self->priv->cur_dir), _tmp0_);
	spek_spectrogram_open (self->priv->spectrogram, file_name);
	gtk_window_set_title ((GtkWindow*) self, _tmp2_ = g_strdup_printf (_ ("Spek - %s"), _tmp1_ = g_path_get_basename (file_name)));
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
}


static void spek_window_on_open_clicked (SpekWindow* self) {
	GtkFileChooserDialog* chooser;
	g_return_if_fail (self != NULL);
	chooser = g_object_ref_sink ((GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Open File"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL, NULL));
	gtk_dialog_set_default_response ((GtkDialog*) chooser, (gint) GTK_RESPONSE_ACCEPT);
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) chooser, FALSE);
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) chooser, self->priv->cur_dir);
	gtk_file_chooser_add_filter ((GtkFileChooser*) chooser, self->priv->filter_all);
	gtk_file_chooser_add_filter ((GtkFileChooser*) chooser, self->priv->filter_audio);
	gtk_file_chooser_set_filter ((GtkFileChooser*) chooser, self->priv->filter_audio);
	if (gtk_dialog_run ((GtkDialog*) chooser) == GTK_RESPONSE_ACCEPT) {
		char* _tmp0_;
		spek_window_open_file (self, _tmp0_ = gtk_file_chooser_get_filename ((GtkFileChooser*) chooser));
		_g_free0 (_tmp0_);
	}
	gtk_object_destroy ((GtkObject*) chooser);
	_g_object_unref0 (chooser);
}


static void spek_window_on_save_clicked (SpekWindow* self) {
	GtkFileChooserDialog* chooser;
	char* _tmp0_;
	char* file_name;
	char* _tmp2_;
	g_return_if_fail (self != NULL);
	chooser = g_object_ref_sink ((GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Save Spectrogram"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SAVE, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, NULL, NULL));
	gtk_dialog_set_default_response ((GtkDialog*) chooser, (gint) GTK_RESPONSE_ACCEPT);
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) chooser, self->priv->cur_dir);
	_tmp0_ = g_strdup (spek_spectrogram_get_file_name (self->priv->spectrogram));
	if (_tmp0_ == NULL) {
		char* _tmp1_;
		_tmp0_ = (_tmp1_ = g_strdup (_ ("Untitled")), _g_free0 (_tmp0_), _tmp1_);
	}
	file_name = g_path_get_basename (_tmp0_);
	file_name = (_tmp2_ = g_strconcat (file_name, ".png", NULL), _g_free0 (file_name), _tmp2_);
	gtk_file_chooser_set_current_name ((GtkFileChooser*) chooser, file_name);
	gtk_file_chooser_add_filter ((GtkFileChooser*) chooser, self->priv->filter_png);
	gtk_file_chooser_set_filter ((GtkFileChooser*) chooser, self->priv->filter_png);
	if (gtk_dialog_run ((GtkDialog*) chooser) == GTK_RESPONSE_ACCEPT) {
		char* _tmp3_;
		char* _tmp4_;
		file_name = (_tmp3_ = gtk_file_chooser_get_filename ((GtkFileChooser*) chooser), _g_free0 (file_name), _tmp3_);
		self->priv->cur_dir = (_tmp4_ = g_path_get_dirname (file_name), _g_free0 (self->priv->cur_dir), _tmp4_);
		spek_spectrogram_save (self->priv->spectrogram, file_name);
	}
	gtk_object_destroy ((GtkObject*) chooser);
	_g_object_unref0 (chooser);
	_g_free0 (_tmp0_);
	_g_free0 (file_name);
}


static void _lambda9_ (gint id, Block3Data* _data3_) {
	SpekWindow * self;
	self = _data3_->self;
	gtk_object_destroy ((GtkObject*) _data3_->dlg);
}


static void __lambda9__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	_lambda9_ (response_id, self);
}


static void _spek_window_url_hook_gtk_about_dialog_activate_link_func (GtkAboutDialog* about, const char* link_, gpointer self) {
	spek_window_url_hook (self, about, link_);
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	++_data3_->_ref_count_;
	return _data3_;
}


static void block3_data_unref (Block3Data* _data3_) {
	if ((--_data3_->_ref_count_) == 0) {
		_g_object_unref0 (_data3_->self);
		_g_object_unref0 (_data3_->dlg);
		g_slice_free (Block3Data, _data3_);
	}
}


static void spek_window_on_about_clicked (SpekWindow* self) {
	Block3Data* _data3_;
	char** _tmp1_;
	gint _authors_size_;
	gint authors_length1;
	char** _tmp0_ = NULL;
	char** authors;
	char** _tmp3_;
	gint _artists_size_;
	gint artists_length1;
	char** _tmp2_ = NULL;
	char** artists;
	char* license;
	char* _tmp4_;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	char* _tmp11_;
	char* _tmp12_;
	char* _tmp13_;
	char* _tmp14_;
	char* _tmp15_;
	char* _tmp16_;
	g_return_if_fail (self != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	authors = (_tmp1_ = (_tmp0_ = g_new0 (char*, 5 + 1), _tmp0_[0] = g_strdup ("Primary Development:"), _tmp0_[1] = g_strdup ("\tAlexander Kojevnikov (maintainer) <alexander@kojevnikov.com>"), _tmp0_[2] = g_strdup (""), _tmp0_[3] = g_strdup ("Contributors:"), _tmp0_[4] = g_strdup ("\tFabian Deutsch"), _tmp0_), authors_length1 = 5, _authors_size_ = authors_length1, _tmp1_);
	artists = (_tmp3_ = (_tmp2_ = g_new0 (char*, 1 + 1), _tmp2_[0] = g_strdup ("Olga Vasylevska"), _tmp2_), artists_length1 = 1, _artists_size_ = artists_length1, _tmp3_);
	license = g_strdup ("Copyright (C) 2010  Alexander Kojevnikov");
	license = (_tmp4_ = g_strconcat (license, "\n\n", NULL), _g_free0 (license), _tmp4_);
	license = (_tmp5_ = g_strconcat (license, "Spek is free software: you can redistribute it and/or modify ", NULL), _g_free0 (license), _tmp5_);
	license = (_tmp6_ = g_strconcat (license, "it under the terms of the GNU General Public License as published by ", NULL), _g_free0 (license), _tmp6_);
	license = (_tmp7_ = g_strconcat (license, "the Free Software Foundation, either version 3 of the License, or ", NULL), _g_free0 (license), _tmp7_);
	license = (_tmp8_ = g_strconcat (license, "(at your option) any later version.", NULL), _g_free0 (license), _tmp8_);
	license = (_tmp9_ = g_strconcat (license, "\n\n", NULL), _g_free0 (license), _tmp9_);
	license = (_tmp10_ = g_strconcat (license, "Spek is distributed in the hope that it will be useful, ", NULL), _g_free0 (license), _tmp10_);
	license = (_tmp11_ = g_strconcat (license, "but WITHOUT ANY WARRANTY; without even the implied warranty of ", NULL), _g_free0 (license), _tmp11_);
	license = (_tmp12_ = g_strconcat (license, "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the ", NULL), _g_free0 (license), _tmp12_);
	license = (_tmp13_ = g_strconcat (license, "GNU General Public License for more details.", NULL), _g_free0 (license), _tmp13_);
	license = (_tmp14_ = g_strconcat (license, "\n\n", NULL), _g_free0 (license), _tmp14_);
	license = (_tmp15_ = g_strconcat (license, "You should have received a copy of the GNU General Public License ", NULL), _g_free0 (license), _tmp15_);
	license = (_tmp16_ = g_strconcat (license, "along with Spek.  If not, see http://www.gnu.org/licenses/", NULL), _g_free0 (license), _tmp16_);
	_data3_->dlg = g_object_ref_sink ((GtkAboutDialog*) gtk_about_dialog_new ());
	gtk_about_dialog_set_program_name (_data3_->dlg, "Spek");
	gtk_about_dialog_set_version (_data3_->dlg, PACKAGE_VERSION);
	gtk_about_dialog_set_copyright (_data3_->dlg, _ ("Copyright \xc2\xa9 2010 Alexander Kojevnikov"));
	gtk_about_dialog_set_comments (_data3_->dlg, SPEK_WINDOW_full_title);
	g_object_set ((GObject*) _data3_->dlg, "authors", authors, NULL);
	g_object_set ((GObject*) _data3_->dlg, "artists", artists, NULL);
	gtk_about_dialog_set_website_label (_data3_->dlg, _ ("Spek Website"));
	gtk_about_dialog_set_website (_data3_->dlg, "http://www.spek-project.org/");
	gtk_about_dialog_set_license (_data3_->dlg, license);
	gtk_about_dialog_set_wrap_license (_data3_->dlg, TRUE);
	gtk_about_dialog_set_logo_icon_name (_data3_->dlg, "spek");
	gtk_about_dialog_set_translator_credits (_data3_->dlg, _ ("translator-credits"));
	gtk_window_set_transient_for ((GtkWindow*) _data3_->dlg, (GtkWindow*) self);
	gtk_window_set_destroy_with_parent ((GtkWindow*) _data3_->dlg, TRUE);
	g_signal_connect_data ((GtkDialog*) _data3_->dlg, "response", (GCallback) __lambda9__gtk_dialog_response, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	gtk_about_dialog_set_url_hook (_spek_window_url_hook_gtk_about_dialog_activate_link_func, g_object_ref (self), g_object_unref);
	gtk_window_present ((GtkWindow*) _data3_->dlg);
	authors = (_vala_array_free (authors, authors_length1, (GDestroyNotify) g_free), NULL);
	artists = (_vala_array_free (artists, artists_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (license);
	block3_data_unref (_data3_);
}


static void spek_window_url_hook (SpekWindow* self, GtkAboutDialog* about, const char* link) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (about != NULL);
	g_return_if_fail (link != NULL);
	spek_platform_show_uri (link);
}


static gboolean _lambda10_ (SpekWindow* self) {
	gboolean result = FALSE;
	gtk_widget_show_all ((GtkWidget*) self->priv->message_bar);
	result = FALSE;
	return result;
}


static gboolean __lambda10__gsource_func (gpointer self) {
	return _lambda10_ (self);
}


static void* spek_window_check_version (SpekWindow* self) {
	void* result = NULL;
	GError * _inner_error_;
	char* config;
	char* _tmp0_;
	GKeyFile* key_file;
	gboolean check;
	GTimeVal time_val = {0};
	GDate today = {0};
	gint day;
	gint diff;
	GFile* file;
	char* version;
	FILE* output;
	char* _tmp8_;
	gboolean _tmp9_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	_inner_error_ = NULL;
	config = g_build_filename (g_get_user_config_dir (), "spek", NULL);
	g_mkdir_with_parents (config, 0755);
	config = (_tmp0_ = g_build_filename (config, "config.ini", NULL), _g_free0 (config), _tmp0_);
	key_file = g_key_file_new ();
	{
		g_key_file_load_from_file (key_file, config, G_KEY_FILE_NONE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch8_g_key_file_error;
			}
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch8_g_file_error;
			}
			_g_free0 (config);
			_g_key_file_free0 (key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	goto __finally8;
	__catch8_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	goto __finally8;
	__catch8_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	__finally8:
	if (_inner_error_ != NULL) {
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	check = TRUE;
	{
		gboolean _tmp1_;
		_tmp1_ = g_key_file_get_boolean (key_file, "update", "check", &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch9_g_key_file_error;
			}
			_g_free0 (config);
			_g_key_file_free0 (key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		check = _tmp1_;
	}
	goto __finally9;
	__catch9_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			check = TRUE;
			_g_error_free0 (e);
		}
	}
	__finally9:
	if (_inner_error_ != NULL) {
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (!check) {
		result = NULL;
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		return result;
	}
	g_get_current_time (&time_val);
	g_get_current_time (&time_val);
	memset (&today, 0, sizeof (GDate));
	g_date_set_time_val (&today, &time_val);
	day = 0;
	{
		gint _tmp2_;
		_tmp2_ = g_key_file_get_integer (key_file, "update", "last_update", &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch10_g_key_file_error;
			}
			_g_free0 (config);
			_g_key_file_free0 (key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		day = _tmp2_;
	}
	goto __finally10;
	__catch10_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			day = 0;
			_g_error_free0 (e);
		}
	}
	__finally10:
	if (_inner_error_ != NULL) {
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	diff = ((gint) g_date_get_julian (&today)) - day;
	if (diff < 7) {
		result = NULL;
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		return result;
	}
	file = g_file_new_for_uri ("http://www.spek-project.org/version");
	if (!g_file_query_exists (file, NULL)) {
		result = NULL;
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		_g_object_unref0 (file);
		return result;
	}
	version = NULL;
	{
		GFileInputStream* _tmp3_;
		GFileInputStream* _tmp4_;
		GDataInputStream* _tmp5_;
		GDataInputStream* stream;
		char* _tmp6_;
		char* _tmp7_;
		_tmp3_ = g_file_read (file, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch11_g_error;
		}
		stream = (_tmp5_ = g_data_input_stream_new ((GInputStream*) (_tmp4_ = _tmp3_)), _g_object_unref0 (_tmp4_), _tmp5_);
		_tmp6_ = g_data_input_stream_read_line (stream, NULL, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (stream);
			goto __catch11_g_error;
		}
		version = (_tmp7_ = _tmp6_, _g_free0 (version), _tmp7_);
		_g_object_unref0 (stream);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			result = NULL;
			_g_error_free0 (e);
			_g_free0 (config);
			_g_key_file_free0 (key_file);
			_g_object_unref0 (file);
			_g_free0 (version);
			return result;
		}
	}
	__finally11:
	if (_inner_error_ != NULL) {
		_g_free0 (config);
		_g_key_file_free0 (key_file);
		_g_object_unref0 (file);
		_g_free0 (version);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	g_key_file_set_boolean (key_file, "update", "check", check);
	g_key_file_set_integer (key_file, "update", "last_update", (gint) g_date_get_julian (&today));
	output = fopen (config, "w+");
	fputs (_tmp8_ = g_key_file_to_data (key_file, NULL, NULL), output);
	_g_free0 (_tmp8_);
	if (version != NULL) {
		_tmp9_ = _vala_strcmp0 (version, PACKAGE_VERSION) > 0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda10__gsource_func, g_object_ref (self), g_object_unref);
	}
	result = NULL;
	_g_free0 (config);
	_g_key_file_free0 (key_file);
	_g_object_unref0 (file);
	_g_free0 (version);
	_fclose0 (output);
	return result;
}


static void spek_window_class_init (SpekWindowClass * klass) {
	spek_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SpekWindowPrivate));
	G_OBJECT_CLASS (klass)->finalize = spek_window_finalize;
}


static void spek_window_instance_init (SpekWindow * self) {
	char** _tmp0_ = NULL;
	self->priv = SPEK_WINDOW_GET_PRIVATE (self);
	self->priv->audio_extensions = (_tmp0_ = g_new0 (char*, 27 + 1), _tmp0_[0] = g_strdup ("*.3gp"), _tmp0_[1] = g_strdup ("*.aac"), _tmp0_[2] = g_strdup ("*.aif"), _tmp0_[3] = g_strdup ("*.aifc"), _tmp0_[4] = g_strdup ("*.aiff"), _tmp0_[5] = g_strdup ("*.amr"), _tmp0_[6] = g_strdup ("*.awb"), _tmp0_[7] = g_strdup ("*.ape"), _tmp0_[8] = g_strdup ("*.au"), _tmp0_[9] = g_strdup ("*.dts"), _tmp0_[10] = g_strdup ("*.flac"), _tmp0_[11] = g_strdup ("*.gsm"), _tmp0_[12] = g_strdup ("*.m4a"), _tmp0_[13] = g_strdup ("*.m4p"), _tmp0_[14] = g_strdup ("*.mp3"), _tmp0_[15] = g_strdup ("*.mp4"), _tmp0_[16] = g_strdup ("*.mp+"), _tmp0_[17] = g_strdup ("*.mpc"), _tmp0_[18] = g_strdup ("*.mpp"), _tmp0_[19] = g_strdup ("*.oga"), _tmp0_[20] = g_strdup ("*.ogg"), _tmp0_[21] = g_strdup ("*.ra"), _tmp0_[22] = g_strdup ("*.ram"), _tmp0_[23] = g_strdup ("*.snd"), _tmp0_[24] = g_strdup ("*.wav"), _tmp0_[25] = g_strdup ("*.wma"), _tmp0_[26] = g_strdup ("*.wv"), _tmp0_);
	self->priv->audio_extensions_length1 = 27;
	self->priv->_audio_extensions_size_ = self->priv->audio_extensions_length1;
}


static void spek_window_finalize (GObject* obj) {
	SpekWindow * self;
	self = SPEK_WINDOW (obj);
	_g_object_unref0 (self->priv->message_bar);
	_g_object_unref0 (self->priv->spectrogram);
	_g_free0 (self->priv->cur_dir);
	_g_object_unref0 (self->priv->filter_all);
	_g_object_unref0 (self->priv->filter_audio);
	_g_object_unref0 (self->priv->filter_png);
	self->priv->audio_extensions = (_vala_array_free (self->priv->audio_extensions, self->priv->audio_extensions_length1, (GDestroyNotify) g_free), NULL);
	G_OBJECT_CLASS (spek_window_parent_class)->finalize (obj);
}


GType spek_window_get_type (void) {
	static volatile gsize spek_window_type_id__volatile = 0;
	if (g_once_init_enter (&spek_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SpekWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) spek_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SpekWindow), 0, (GInstanceInitFunc) spek_window_instance_init, NULL };
		GType spek_window_type_id;
		spek_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "SpekWindow", &g_define_type_info, 0);
		g_once_init_leave (&spek_window_type_id__volatile, spek_window_type_id);
	}
	return spek_window_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




